from number_transcription.enums import GenderEnum
from .enums import RussianUnit


SHORT_THOUSAND_POWERS = (
    RussianUnit(one="тысяча", any="тысячи", many="тысяч", gender=GenderEnum.FEMALE),
    RussianUnit(one="миллион", any="миллиона", many="миллионов", gender=GenderEnum.MALE),
    RussianUnit(one="миллиард", any="миллиарда", many="миллиардов", gender=GenderEnum.MALE),
    RussianUnit(one="триллион", any="триллиона", many="триллионов", gender=GenderEnum.MALE),
    RussianUnit(one="квадриллион", any="квадриллиона", many="квадриллионов",
                gender=GenderEnum.MALE),
    RussianUnit(one="квинтиллион", any="квинтиллиона", many="квинтиллионов",
                gender=GenderEnum.MALE),
    RussianUnit(one="секстиллион", any="секстиллиона", many="секстиллионов",
                gender=GenderEnum.MALE),
    RussianUnit(one="септиллион", any="септиллиона", many="септиллионов", gender=GenderEnum.MALE),
    RussianUnit(one="октиллион", any="октиллиона", many="октиллионов", gender=GenderEnum.MALE),
    RussianUnit(one="нониллион", any="нониллиона", many="нониллионов", gender=GenderEnum.MALE),
    RussianUnit(one="дециллион", any="дециллиона", many="дециллионов", gender=GenderEnum.MALE),
    RussianUnit(one="ундециллион", any="ундециллиона", many="ундециллионов",
                gender=GenderEnum.MALE),
    RussianUnit(one="дуодециллион", any="дуодециллиона", many="дуодециллионов",
                gender=GenderEnum.MALE),
    RussianUnit(one="тредециллион", any="тредециллиона", many="тредециллионов",
                gender=GenderEnum.MALE),
    RussianUnit(one="кваттордециллион", any="кваттордециллиона", many="кваттордециллионов",
                gender=GenderEnum.MALE),
    RussianUnit(one="квиндециллион", any="квиндециллиона", many="квиндециллионов",
                gender=GenderEnum.MALE),
    RussianUnit(one="сексдециллион", any="сексдециллиона", many="сексдециллионов",
                gender=GenderEnum.MALE),
    RussianUnit(one="септендециллион", any="септендециллиона", many="септендециллионов",
                gender=GenderEnum.MALE),
    RussianUnit(one="октодециллион", any="октодециллиона", many="октодециллионов",
                gender=GenderEnum.MALE),
    RussianUnit(one="новемдециллион", any="новемдециллиона", many="новемдециллионов",
                gender=GenderEnum.MALE),
    RussianUnit(one="вигинтиллион", any="вигинтиллиона", many="вигинтиллионов",
                gender=GenderEnum.MALE),
)
LONG_THOUSAND_POWERS = (
    RussianUnit(one="тысяча", any="тысячи", many="тысяч", gender=GenderEnum.FEMALE),
    RussianUnit(one="миллион", any="миллиона", many="миллионов", gender=GenderEnum.MALE),
    RussianUnit(one="миллиард", any="миллиарда", many="миллиардов", gender=GenderEnum.MALE),
    RussianUnit(one="биллион", any="биллиона", many="биллионов", gender=GenderEnum.MALE),
    RussianUnit(one="биллиард", any="биллиарда", many="биллиардов", gender=GenderEnum.MALE),
    RussianUnit(one="триллион", any="триллиона", many="триллионов", gender=GenderEnum.MALE),
    RussianUnit(one="триллиард", any="триллиарда", many="триллиардов", gender=GenderEnum.MALE),
    RussianUnit(one="квадриллион", any="квадриллиона", many="квадриллионов",
                gender=GenderEnum.MALE),
    RussianUnit(one="квадриллиард", any="квадриллиарда", many="квадриллиардов",
                gender=GenderEnum.MALE),
    RussianUnit(one="квинтиллион", any="квинтиллиона", many="квинтиллионов",
                gender=GenderEnum.MALE),
    RussianUnit(one="квинтиллиард", any="квинтиллиарда", many="квинтиллиардов",
                gender=GenderEnum.MALE),
    RussianUnit(one="секстиллион", any="секстиллиона", many="секстиллионов",
                gender=GenderEnum.MALE),
    RussianUnit(one="секстиллиард", any="секстиллиарда", many="секстиллиардов",
                gender=GenderEnum.MALE),
    RussianUnit(one="септиллион", any="септиллиона", many="септиллионов", gender=GenderEnum.MALE),
    RussianUnit(one="септиллиард", any="септиллиарда", many="септиллиардов",
                    gender=GenderEnum.MALE),
    RussianUnit(one="октиллион", any="октиллиона", many="октиллионов", gender=GenderEnum.MALE),
    RussianUnit(one="октиллиард", any="октиллиарда", many="октиллиардов", gender=GenderEnum.MALE),
    RussianUnit(one="нониллион", any="нониллиона", many="нониллионов", gender=GenderEnum.MALE),
    RussianUnit(one="нониллиард", any="нониллиарда", many="нониллиардов", gender=GenderEnum.MALE),
    RussianUnit(one="дециллион", any="дециллиона", many="дециллионов", gender=GenderEnum.MALE),
    RussianUnit(one="дециллиард", any="дециллиарда", many="дециллиардов", gender=GenderEnum.MALE),
    None,
    RussianUnit(one="ундециллион", any="ундециллиона", many="ундециллионов",
                gender=GenderEnum.MALE),
    None,
    RussianUnit(one="дуодециллион", any="дуодециллиона", many="дуодециллионов",
                gender=GenderEnum.MALE),
    None,
    RussianUnit(one="тредециллион", any="тредециллиона", many="тредециллионов",
                gender=GenderEnum.MALE),
    None,
    RussianUnit(one="кваттордециллион", any="кваттордециллиона", many="кваттордециллионов",
                gender=GenderEnum.MALE),
    None,
    RussianUnit(one="квиндециллион", any="квиндециллиона", many="квиндециллионов",
                gender=GenderEnum.MALE),
    None,
    RussianUnit(one="сексдециллион", any="сексдециллиона", many="сексдециллионов",
                gender=GenderEnum.MALE),
    None,
    RussianUnit(one="септендециллион", any="септендециллиона", many="септендециллионов",
                gender=GenderEnum.MALE),
    None,
    RussianUnit(one="октодециллион", any="октодециллиона", many="октодециллионов",
                gender=GenderEnum.MALE),
    None,
    RussianUnit(one="новемдециллион", any="новемдециллиона", many="новемдециллионов",
                gender=GenderEnum.MALE),
    None,
    RussianUnit(one="вигинтиллион", any="вигинтиллиона", many="вигинтиллионов",
                gender=GenderEnum.MALE),
)
HUNDREDS = {
    1: "сто",
    2: "двести",
    3: "триста",
    4: "четыреста",
    5: "пятьсот",
    6: "шестьсот",
    7: "семьсот",
    8: "восемьсот",
    9: "девятьсот",
}
DOZENS = {
    2: "двадцать",
    3: "тридцать",
    4: "сорок",
    5: "пятьдесят",
    6: "шестьдесят",
    7: "семьдесят",
    8: "восемьдесят",
    9: "девяносто",
}
ONE_DOZEN = {
    10: "десять",
    11: "одиннадцать",
    12: "двенадцать",
    13: "тринадцать",
    14: "четырнадцать",
    15: "пятнадцать",
    16: "шестнадцать",
    17: "семнадцать",
    18: "восемнадцать",
    19: "девятнадцать",
}
UNITS = {
    0: lambda gender: "ноль",
    1: lambda gender: "один" if gender == GenderEnum.MALE else "одна",
    2: lambda gender: "два" if gender == GenderEnum.MALE else "две",
    3: lambda gender: "три",
    4: lambda gender: "четыре",
    5: lambda gender: "пять",
    6: lambda gender: "шесть",
    7: lambda gender: "семь",
    8: lambda gender: "восемь",
    9: lambda gender: "девять",
}
